"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const equality_comparer_1 = require("../equality-comparer");
const grouping_1 = require("../grouping");
const enumerable_container_1 = require("./enumerable-container");
const utils = __importStar(require("../utils"));
const assistance = __importStar(require("./assistance"));
function groupBy(source, keySelector, elementSelector, comparer) {
    utils.throws.ThrowIfNull('source', source);
    utils.throws.ThrowIfNull('keySelector', keySelector);
    let _elementSelector = elementSelector || (x => x);
    comparer = comparer || equality_comparer_1.EqualityComparer.Default();
    return new enumerable_container_1.EnumerableContainer(assistance
        .group(source, keySelector, _elementSelector, (x, y) => comparer.Equals(x, y))
        .map(g => new grouping_1.Grouping(g.Key, new enumerable_container_1.EnumerableContainer(g.List))));
}
exports.groupBy = groupBy;
//# sourceMappingURL=group-by.js.map