"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const exceptions_1 = require("../exceptions");
const utils = __importStar(require("../utils"));
function max(source, selector) {
    utils.throws.ThrowIfNull('source', source);
    selector =
        selector ||
            (x => {
                if (utils.IsNullOrUndefined(x)) {
                    return null;
                }
                if (typeof x === 'number') {
                    return x;
                }
                else {
                    throw new exceptions_1.ArgumentNullException('selector', '数值类型以外的数组必须传入 selector');
                }
            });
    let found = false;
    let target;
    for (let item of source) {
        let value = selector(item);
        if (!utils.IsNullOrUndefined(value)) {
            if (!found) {
                target = value;
                found = true;
            }
            else {
                if (value > target) {
                    target = value;
                }
            }
        }
    }
    if (found) {
        return target;
    }
    return null;
}
exports.max = max;
//# sourceMappingURL=max.js.map