"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const enumerable_container_1 = require("./enumerable-container");
const utils = __importStar(require("../utils"));
function selectMany(source, collectionSelector, resultSelector) {
    utils.throws.ThrowIfNull('source', source);
    utils.throws.ThrowIfNull('collectionSelector', collectionSelector);
    let _resultSelector = resultSelector || ((item, collection) => collection);
    return new enumerable_container_1.EnumerableContainer([
        ...mapping(source, collectionSelector, _resultSelector)
    ]);
}
exports.selectMany = selectMany;
function* mapping(source, collectionSelector, resultSelector) {
    let index = 0;
    for (let item of source) {
        let collections = collectionSelector(item, index++);
        if (collections) {
            for (let collection of collections) {
                yield resultSelector(item, collection);
            }
        }
    }
}
//# sourceMappingURL=select-many.js.map