"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const equality_comparer_1 = require("../equality-comparer");
const utils = __importStar(require("../utils"));
function sequenceEqual(first, second, comparer) {
    utils.throws.ThrowIfNull('first', first);
    utils.throws.ThrowIfNull('second', second);
    comparer = comparer || equality_comparer_1.EqualityComparer.Default();
    let left = first[Symbol.iterator]();
    let right = second[Symbol.iterator]();
    while (true) {
        let x = left.next();
        let y = right.next();
        if (x.done) {
            return y.done;
        }
        else if (y.done) {
            return false;
        }
        if (!comparer.Equals(x.value, y.value)) {
            return false;
        }
    }
}
exports.sequenceEqual = sequenceEqual;
//# sourceMappingURL=sequence-equal.js.map