"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const enumerable_container_1 = require("./enumerable-container");
const utils = __importStar(require("../utils"));
function skipWhile(source, predicate) {
    utils.throws.ThrowIfNull('source', source);
    utils.throws.ThrowIfNull('predicate', predicate);
    return new enumerable_container_1.EnumerableContainer([...process(source, predicate)]);
}
exports.skipWhile = skipWhile;
function* process(source, predicate) {
    let i = 0;
    let skip = false;
    for (let item of source) {
        if (!skip) {
            if (predicate(item, i++)) {
                continue;
            }
            skip = true;
        }
        yield item;
    }
}
//# sourceMappingURL=skip-while.js.map