"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const dictionary_1 = require("../dictionary");
const equality_comparer_1 = require("../equality-comparer");
const utils = __importStar(require("../utils"));
function toDictionary(source, keySelector, elementSelector, comparer) {
    utils.throws.ThrowIfNull('source', source);
    utils.throws.ThrowIfNull('keySelector', keySelector);
    let _elementSelector = elementSelector || (x => x);
    comparer = comparer || equality_comparer_1.EqualityComparer.Default();
    let dictionary = new dictionary_1.Dictionary(null, comparer);
    for (let item of source) {
        let key = keySelector(item);
        let value = _elementSelector(item);
        dictionary.Add(key, value);
    }
    return dictionary;
}
exports.toDictionary = toDictionary;
//# sourceMappingURL=to-dictionary.js.map